#ifndef ___mpint_h
#define ___mpint_h

#include <mpint.h>

#define _mp_min(A, B)	(((A) < (B)) ? (A) : (B))
#define _mp_max(A, B)	(((A) > (B)) ? (A) : (B))

#if defined(__x86_64__)
# define __MP_64__ 1
#endif

typedef	ssize_t		mp_ssize_t;

#define MP_BYTES	(sizeof(mp_digit_t))
#define MP_BITS		(8 * MP_BYTES)

#include <stdlib.h>
#include <string.h>

MP_INL mp_digit_t *_mp_realloc(mp_digit_t *bits, mp_size_t size)
{
  size *= MP_BYTES;
  return bits ? realloc(bits, size) : malloc(size);
}

MP_INL mp_t *_mp_grow(mp_t *mp, mp_size_t w)
{
  size_t v= mp->width;
  if (v < w) {
    mp->bits= _mp_realloc(mp->bits, w);
    mp->width= w;
    memset(mp->bits + v, 0, MP_BYTES * (w - v));
  }
  return mp;
}

MP_INL mp_digit_t _mp_digitAt(mp_t *mp, mp_size_t index)
{
  assert(mp->width && mp->bits && index < mp->width);
  return mp->bits[index];
}

MP_INL mp_digit_t _mp_digitAtPut(mp_t *mp, mp_size_t index, mp_digit_t value)
{
  assert(mp->width && mp->bits && index < mp->width);
  return mp->bits[index]= value;
}

#endif /* ___mpint_h */
