/* Copyright (c) 2009 Ian Piumarta
 * All rights reserved.
 * See the file COPYING for details.
 */

#include "_mpint.h"

/* r = r & a */

mp_t *mp_and(mp_t *r, mp_t *a)
{
  if (mp_zerop(r)) return r;
  if (mp_zerop(a)) return mp_clear(r);
  size_t w= _mp_min(r->width, a->width), i= 0;
  while (i < w) {
    mp_digit_t x= _mp_digitAt(r, i), y= _mp_digitAt(a, i), z= x & y;
    _mp_digitAtPut(r, i++, z);
  }
  r->width= w;
  return mp_normalise(r);
}
