/* Copyright (c) 2009 Ian Piumarta
 * All rights reserved.
 * See the file COPYING for details.
 */

#include "_mpint.h"

/* mp = mp << n */

mp_t *mp_shiftl(mp_t *mp, mp_size_t n)
{
  if (!n || mp_zerop(mp)) return mp;
  mp_size_t w= mp->width;
  mp_size_t m= n / MP_BITS;
  if (m) {
    _mp_grow(mp, w + m);
    memmove(mp->bits + m, mp->bits, MP_BYTES * w);
    memset(mp->bits, 0, MP_BYTES * m);
    w += m;
  }
  if (n %= MP_BITS) {
    mp_digit_t c= 0;
    while (m < w) {
      mp_digit2_t d= _mp_digitAt(mp, m);
      d= (d << n) | c;
      _mp_digitAtPut(mp, m++, d);
      c= (d >> MP_BITS);
    }
    if (c) mp_digitAtPut(mp, w, c);
  }
  return mp;
}
